/*******************************************************
 * Laboratory Assignment #1
 *
 * This is a C implementation of an 8 bit shift register that
 * uses an internal delay loop for subdividing the
 * external clock.
 *
 * The following is the structure we will use for the
 * ATMEL AVR atmega16 chip.
 *
 * PortB	  -- Drive the LEDs
 * PortC (P0) -- Used by BootLoader to enable you to
 *				 program the chip. If you need this port
 *				 it will require some extra hardware to
 *				 to get it done.
 *
 *******************************************************/
#include <io.h>

int main(void)
{

	unsigned char i, j, k, cnt;
	
	cnt = 1;
	
	// There are several ways of doing register assignments.
	// The first is using outp(val, register). But this is being
	// depricated. The current way that is suggested by the maintainers
	// of AVR-gcc is to do direct assignments as follows:
	
	// Turn port B into outputs.
	DDRB = 0xff;
	
	for(;;)
	{
		PORTB = ~cnt;	/* invert the output since a zero means: LED on */
				
       		cnt <<= 1;              /* move to next LED */
		if (!cnt)               /* overflow: start with Port B0 again */
			cnt = 1;
						
		// The following is a delay loop. You must turn of optimizations
		// or else the following three lines will be optimized away and
		// you will see a constant on the output.
		for (i = 0; i < 255; i++)
			for (j = 0; j < 255; j++)
				for (k = 0; k < 1; k++);
	}

	return 0;
}
